#include <iostream.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>

#include "Token.H"

int Token::Type ()
{
  return type;
}

char *Token::String ()
{
  if (type == TYPE_STRING)
    {
      return string;
    }
  return NULL;
}

int Token::Number ()
{
  return number;
}

Token *Token::Array (int element)
{
  if (element >= number || type != TYPE_ARRAY) return NULL;
  
  int cntr = 0;
  Element *p = array;
  while (cntr < element && p != NULL)
    {
      p = p->next;
      cntr++;
    }
  return p->token;
}

int Token::ToHollerith (int fd)
{
  char buf[10];
  sprintf (buf, "%dH", number);
  
  write (fd, buf, strlen (buf));
  if (write (fd, string, number) != number)
    {
      return -1;
    }
  write (fd, "\n", 1);
  
  return 0;
}

#define GET_CHAR read (fd, &chr, 1);

static int chr;

Token::Token (int fd, char recurse)
{
  if (!recurse || chr == '{' || chr == '*')
    {
      type = TYPE_ARRAY;
      array = NULL;
      number = 0;
      
      if (chr != '*')
	{
	  Element *p, *q;
	  GET_CHAR;
	  if (chr == ' ') GET_CHAR;
	  while ( chr != (recurse ? '}' : '\n'))
	    {
	      q = new Element;
	      q->token = new Token (fd, 1);
	      if (array) p->next = q;
	      else array = q;
	      p = q;
	      p->next = NULL;
	      number++;
	    }
	}
      if (chr != '\n') GET_CHAR;
      
      return;
    }
  
  number = 0;
  while (chr >= '0' && chr <= '9')
    {
      number *= 10;
      number += chr - '0';
      GET_CHAR;
    }
  
  if (chr == 'H')
    {
      int tmp;
      int len = 0;
      type = TYPE_STRING;
      string = new char[number + 1];
      do
	{
	  tmp = read (fd, string + len, number - len);
	  if (tmp < 0)
	    {
	      perror ("Failed to read from server");
	      exit (EXIT_FAILURE);
	    }
	  len += tmp;
	}
      while (len < number);
      string[number] = '\0';
      GET_CHAR;
      if (chr != '\n') GET_CHAR;
      return;
    }
  
  if (chr != ' ' && chr != '\n')
    {
      cerr << "Protocol parser error" << endl;
      exit (EXIT_FAILURE);
    }
  if (chr == ' ') GET_CHAR;
  
  type = TYPE_NUMBER;
}

Token::~Token ()
{
  switch (type)
    {
    case TYPE_STRING:
      delete string;
      break;
      
    case TYPE_ARRAY:
      struct Element *p, *q;
      p = array;
      while (p)
	{
	  q = p->next;
	  delete p->token;
	  delete p;
	  p = q;
	}
    }
}
